# initialize new runners
execute as @e[tag=cre8runnew] at @s run function cre8:run_new

# add cre8rund tag to all runners for this tick
# if there is a valid block below the entity, this tag will be removed
tag @e[tag=cre8run, scores={cre8cooldown=0}] add cre8rund
tag @e[tag=cre8rund] add cre8ran
scoreboard players remove @e[tag=cre8run,scores={cre8cooldown=1..}] cre8cooldown 1

# for all with interpolation, save location (for interpolation)
execute as @e[tag=cre8rund, scores={cre8interp=1..}] at @s run function cre8:fromcooldown_pretick

# for [from last tick] section; this part must happen before the heightdiff
execute as @e[tag=cre8run_unout,scores={cre8interpy=-999..}] at @s run function cre8:gototargetpos

# move all runners down by cre8heightdiff
execute as @e[tag=cre8ran] at @s run function cre8:heightdiff_dni
execute as @e[tag=cre8ran] at @s run function cre8:rotdiff_li

# move all runners up by 0.1 blocks to prevent weird issues where `if block ...` detects blocks at y-1 instead of y
execute as @e[tag=cre8ran] at @s run tp @s ~ ~0.1 ~

# -- redstone: wait --
execute as @e[tag=cre8rund] at @s if block ~ ~-1 ~ minecraft:black_glazed_terracotta run function cre8:run_tick_redstone_wait

# from last tick: unpower lightning rods (happens after values, possibly from said lightning rods, are read)
execute as @e[tag=cre8run_unout,tag=cre8rund] at @s if block ^ ^ ^-1 minecraft:lightning_rod[powered=true] run setblock ^ ^ ^-1 minecraft:lightning_rod[powered=false]
execute as @e[tag=cre8run_unout,tag=cre8rund] run tag @s remove cre8run_unout

# -- redstone: output --
execute as @e[tag=cre8rund] at @s if block ~ ~-1 ~ minecraft:red_glazed_terracotta run function cre8:run_tick_redstone_out
# -- direction --
execute as @e[tag=cre8rund] at @s if block ~ ~-1 ~ minecraft:magenta_glazed_terracotta run function cre8:run_tick_dir
# -- conditional move --
execute as @e[tag=cre8rund] at @s if block ~ ~-1 ~ minecraft:pink_glazed_terracotta run function cre8:run_tick_condmv
# -- move down --
execute as @e[tag=cre8rund] at @s if block ~ ~-1 ~ minecraft:purple_glazed_terracotta run function cre8:run_tick_mvdown

# move forward
execute as @e[tag=cre8runmv] at @s run tp @s ^ ^ ^1
execute as @e[tag=cre8runmv] run tag @s remove cre8runmv

# == apply settings ==
execute as @e[tag=cre8ran] at @s run function cre8:ctick_try_apply_settings
execute as @e[tag=cre8ran] at @s positioned ~ ~-2 ~ run function cre8:ctick_try_apply_settings
tag @e[tag=cre8appliedsettings] remove cre8appliedsettings

# move all runners down by 0.1 blocks again
execute as @e[tag=cre8ran] at @s run tp @s ~ ~-0.1 ~

# lock to integer coordinates
execute as @e[tag=cre8ran,tag=!cre8dontlocktointpos] unless score @s cre8invalidtime matches 1.. at @s positioned ~ ~0.0078125 ~ run function cre8:lock_to_int_coords

# move all runners up by cre8heightdiff again
execute as @e[tag=cre8ran] at @s run function cre8:heightdiff_upi
execute as @e[tag=cre8ran] at @s run function cre8:rotdiff_ri

# remove cre8-entity status if invalid block for too long
## cre8ran = actually ran this tick
tag @e[tag=cre8rund] remove cre8ran
## didn't run this tick, add 1 to invalidtime
scoreboard players add @e[tag=cre8rund] cre8invalidtime 1
## if invalid for too long, remove cre8run status
execute as @e[tag=cre8rund] if score @s cre8invalidtime > allow_invalid_duration cre8config at @s run function cre8:run_new_undo
## instantly retry
scoreboard players set @e[tag=cre8rund] cre8cooldown 0
## all who did run: reset cre8invalidtime
scoreboard players reset @e[tag=cre8ran] cre8invalidtime

# reset cooldown (cre8ranidle -> didn't *really* do anything, so don't set the cooldown)
execute as @e[tag=cre8ran,tag=!cre8ranidle] run scoreboard players operation @s cre8cooldown = @s cre8speed

# for interpolation
execute as @e[tag=cre8interpposttick] at @s run function cre8:fromcooldown_posttick
execute as @e[tag=cre8run,scores={cre8interpy=-999..}] at @s run function cre8:oncooldown_interp

# remove tags
tag @e[tag=cre8rund] remove cre8rund
tag @e[tag=cre8ran] remove cre8ran
tag @e[tag=cre8ranidle] remove cre8ranidle

# loop if cre8config/speed > 1
scoreboard players remove tc cre8temp 1
function cre8:ctickif
